本文主要是介绍DP-HDU-5773-The All-purpose Zero,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!
The All-purpose Zero
Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 65536/65536 K (Java/Others)
Total Submission(s): 279 Accepted Submission(s): 129
Problem Description
?? gets an sequence S with n intergers(0 < n <= 100000,0<= S[i] <= 1000000).?? has a magic so that he can change 0 to any interger(He does not need to change all 0 to the same interger).?? wants you to help him to find out the length of the longest increasing (strictly) subsequence he can get.
Input
The first line contains an interger T,denoting the number of the test cases.(T <= 10)
For each case,the first line contains an interger n,which is the length of the array s.
The next line contains n intergers separated by a single space, denote each number in S.
Output
For each test case, output one line containing “Case #x: y”(without quotes), where x is the test case number(starting from 1) and y is the length of the longest increasing subsequence he can get.
Sample Input
2
7
2 0 2 1 2 0 5
6
1 2 3 3 0 0
Sample Output
Case #1: 5
Case #2: 5
Hint
In the first case,you can change the second 0 to 3.So the longest increasing subsequence is 0 1 2 3 5.
Author
FZU
Source
2016 Multi-University Training Contest 4
题意:
给你一个数组,其中的0可以变成任何数,求最长的LIS是多长。
题解:
因为0可以变成任何数,那么所有的0是绝对要用上的(就算强行用上,顶多是使原LIS保持长度,不会出现用0减长度的情况)。所以把所有的0单独拿出来后,看剩下数的LIS,为了求出的LIS保证在原位置加入0后仍然是LIS,我们将原本非0的元素都减去前方0的个数再去求LIS,这样就能保证如果此数在LIS中,那么加入0以后也一定是LIS。
因为数据大小和时限的原因,用一个二分nlogn的LIS即可。
//
// main.cpp
// 160728-4
//
// Created by 袁子涵 on 16/7/28.
// Copyright © 2016年 袁子涵. All rights reserved.
//#include <iostream>
#include <cstdio>
#include <cstring>
#include <cstdlib>
#include <cmath>
#include <algorithm>
#include <string>
#include <vector>using namespace std;
const int MAXN=100005;
int t,cas;
long long int n,b[MAXN],out,tmp;
long long int num[MAXN];
long long int Search(long long int num,long long int low,long long int high)
{long long int mid;while(low<=high){mid=(low+high)/2;if(num>=b[mid]) low=mid+1;else high=mid-1;}return low;
}
long long int DP(long long int n)
{long long int i,len,pos;b[1]=num[1];len=1;for(i=2;i<=n;i++){if(num[i]>b[len]){len=len+1;b[len]=num[i];}else{pos=Search(num[i],1,len);b[pos]=num[i];}}return len;
}
long long int total=0;
bool flag;
int main(int argc, const char * argv[]) {scanf("%d",&t);while (t--) {long long int now=0;total=0;cas++;scanf("%lld",&n);for (long long int i=1; i<=n; i++) {scanf("%lld",&tmp);if (tmp==0)total++;elsenum[++now]=tmp-total;}out=DP(now);if (total==n)out=0;cout << "Case #" << cas << ": " << out+total << endl;}return 0;
}
这篇关于DP-HDU-5773-The All-purpose Zero的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!